!
! $Id: abort_gcm.F90 5246 2024-10-21 12:58:45Z abarral $
!
!
!
SUBROUTINE abort_gcm(modname, message, ierr)

#ifdef CPP_IOIPSL
  USE IOIPSL
#else
  ! if not using IOIPSL, we still need to use (a local version of) getin_dump
  USE ioipsl_getincom
#endif
  !! ug Pour les sorties XIOS
  USE wxios

#include "iniprint.h"

  !
  ! Stops the simulation cleanly, closing files and printing various
  ! comments
  !
  !  Input: modname = name of calling program
  !     message = stuff to print
  !     ierr    = severity of situation ( = 0 normal )

  character(len=*), intent(in):: modname
  integer, intent(in):: ierr
  character(len=*), intent(in):: message

  write(lunout,*) 'in abort_gcm'

  IF (using_xios) THEN
  !Fermeture propre de XIOS
    CALL wxios_close()
  ENDIF

#ifdef CPP_IOIPSL
  call histclo
  call restclo
#endif
  call getin_dump
  ! call histclo(2)
  ! call histclo(3)
  ! call histclo(4)
  ! call histclo(5)
  write(lunout,*) 'Stopping in ', modname
  write(lunout,*) 'Reason = ',message
  if (ierr .eq. 0) then
    write(lunout,*) 'Everything is cool'
    stop
  else
    write(lunout,*) 'Houston, we have a problem, ierr = ', ierr
    stop 1
  endif
END SUBROUTINE abort_gcm
